//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Goldenrod
#property indicator_color2     DeepPink
#property indicator_color3     LimeGreen
#property indicator_color4     DeepPink
#property indicator_color5     LimeGreen
#property indicator_levelcolor DarkSlateGray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     3
#property indicator_width5     3
#property indicator_minimum    -120
#property indicator_maximum    120

//
//
//
//
//

extern double             AroonPeriod     = 25;
extern double             AdaptPeriod     = 25;
extern ENUM_APPLIED_PRICE Price           = PRICE_CLOSE;
extern int                Filter          = 70;

extern string             Alerts_Settings = "Settings for alerts";
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = false;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = false;
extern bool               alertsEmail     = false;


//
//
//
//
//

double osc[];
double osclu[];
double oscld[];
double oscau[];
double oscad[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,osc);
   SetIndexBuffer(1,osclu);
   SetIndexBuffer(2,oscld);
   SetIndexBuffer(3,oscau); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,oscad); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,108);
   SetIndexBuffer(5,trend);
      SetLevelValue(0, Filter);
      SetLevelValue(1, 0);
      SetLevelValue(2,-Filter);
   
   IndicatorShortName("Adaptive Smoother Aroon oscillator ("+DoubleToStr(AroonPeriod,2)+","+DoubleToStr(AdaptPeriod,2)+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double dev = iStdDev(NULL,0,AdaptPeriod,0,MODE_SMA,Price,i);
      double avg = iSma(dev,AdaptPeriod,i,0);
         if (dev!=0) 
                double period = AroonPeriod*avg/dev;
         else          period = AroonPeriod; 
         if (period<3) period = 3;
         
      //
      //
      //
      //
      //
      
      double AroonUp = 100.0*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod+1,i)+i)/AroonPeriod;
      double AroonDn = 100.0*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod+1,i)+i)/AroonPeriod;
           if (AroonUp != AroonDn)
                 osc[i] = iSmooth(AroonUp-AroonDn,period,i,0);
           else  osc[i] = iSmooth(0,              period,i,0); 
           osclu[i] = EMPTY_VALUE;
           oscld[i] = EMPTY_VALUE;
           oscau[i] = EMPTY_VALUE;
           oscad[i] = EMPTY_VALUE;
           trend[i] = trend[i+1];
              if (osc[i] >  Filter)                     trend[i] =  1;
              if (osc[i] < -Filter)                     trend[i] = -1;
              if (osc[i] <  Filter && osc[i] > -Filter) trend[i] = 0;
              if (trend[i] == 1)
              {
                 osclu[i] = osc[i]; if (trend[i]!=trend[i+1]) oscau[i] = osc[i];
              }
              if (trend[i] == -1)
              {
                 oscld[i] = osc[i]; if (trend[i]!=trend[i+1]) oscad[i] = osc[i];
              }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;
      
      //
      //
      //
      //
      //

      if (oscau[forBar]!= EMPTY_VALUE) doAlert("trend changed to UP");
      if (oscad[forBar]!= EMPTY_VALUE) doAlert("trend changed to DOWN");
   }      
   return(0);
}


//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Aroon oscillator ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail("Aroon oscillator",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSmooth[][5];
double iSmooth(double price, double length, int r, int instanceNo=0)
{
   if (ArrayRange(workSmooth,0)!=Bars) ArrayResize(workSmooth,Bars); instanceNo *= 5; r = Bars-r-1;
 	if(r<=2) { workSmooth[r][instanceNo] = price; workSmooth[r][instanceNo+2] = price; workSmooth[r][instanceNo+4] = price; return(price); }
   
   //
   //
   //
   //
   //
   
	double alpha = 0.45*(length-1.0)/(0.45*(length-1.0)+2.0);
   	  workSmooth[r][instanceNo+0] =  price+alpha*(workSmooth[r-1][instanceNo]-price);
	     workSmooth[r][instanceNo+1] = (price - workSmooth[r][instanceNo])*(1-alpha)+alpha*workSmooth[r-1][instanceNo+1];
	     workSmooth[r][instanceNo+2] =  workSmooth[r][instanceNo+0] + workSmooth[r][instanceNo+1];
	     workSmooth[r][instanceNo+3] = (workSmooth[r][instanceNo+2] - workSmooth[r-1][instanceNo+4])*MathPow(1.0-alpha,2) + MathPow(alpha,2)*workSmooth[r-1][instanceNo+3];
	     workSmooth[r][instanceNo+4] =  workSmooth[r][instanceNo+3] + workSmooth[r-1][instanceNo+4]; 
   return(workSmooth[r][instanceNo+4]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double workSma[][2];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}


